/** @file
    Block collect process (header file).
*/

#ifndef COLLECT_BLOCKS_H
#define COLLECT_BLOCKS_H

#include <dol.h>
#include "global.h"

#define PORT_OUT "out"
#define PORT_IN "in"

//local variables
typedef struct _local_states {
    char id[64];
    char name[15];
    MbDispatchedDatatype mb_dispatched_datatype;
    GopDispatchedDatatype gop_dispatched_datatype;
    BlockDispatchedDatatype block_dispatched_datatype;
    int in_port_count;
    int send_buffer[12][BLOCK_BUFFER_SIZE]; /* a mb has a max. of 12 blocks */
#ifdef DEBUG
    unsigned int block_count;
    unsigned int mb_count;
#endif
} Collect_blocks_State;

/* mandatory prototypes */
void collect_blocks_init(DOLProcess *);
int collect_blocks_fire(DOLProcess *);

/* DOL process declaration */
extern DOLProcess collect_blocks;

/* additional prototypes */
void collect_blocks_finish(DOLProcess *);

/* additional extern function prototypes */
extern void Error(DOLProcess *, char *);

#endif
