/** @file
    Group of picture collect process (header file).
*/

#ifndef COLLECT_GOPS_H
#define COLLECT_GOPS_H

#include <dol.h>
#include "global.h"

#define PORT_IN "in"

//local variables
typedef struct _local_states {
    char id[64];
    char name[15];
    int gop_count;
    int frame_count;
    int in_port_count;
    GopDispatchedDatatype gop_dispatched_datatype;
    MbDispatchedDatatype mb_dispatched_datatype;    
    unsigned char *Clip;    
    /* output buffer variables used by store.c */
    unsigned char obfr[OBFRSIZE];
    unsigned char *optr;
    FILE *outfile;        
} Collect_gops_State;

/* mandatory function prototypes */
void collect_gops_init(DOLProcess *);
int collect_gops_fire(DOLProcess *);

/* DOL process declaration */
extern DOLProcess collect_gops;

/* additional function prototypes */
void collect_gops_finish(DOLProcess *);

/* additional extern function prototypes */
extern void Error(DOLProcess *, char *);

#endif
