/** @file
    Macroblock collect process (header file).
*/

#ifndef COLLECT_MB_H
#define COLLECT_MB_H

#include <dol.h>
#include "global.h"

#define PORT_OUT "out"
#define PORT_IN "in"

//local variables
typedef struct _local_states {
    char id[64];
    char name[15];
    MbDispatchedDatatype mb_dispatched_datatype;
    GopDispatchedDatatype gop_dispatched_datatype;
    int in_port_count;
    int read_buffer[12][BLOCK_BUFFER_SIZE]; // a mb has a max. of 12 blocks
    int *current_picture[3];
    bool first_mb;
    bool first_pic_of_gop;
    bool pic_end_flag; // checks for consistency (pic start follows pic end)
    unsigned char *Clip;
    /* pointers to picture buffers */
    unsigned char *backward_reference_frame[3];
    unsigned char *forward_reference_frame[3];
    unsigned char *auxframe[3];
    unsigned char *current_frame[3];
 } Collect_mb_State;

/* mandatory function prototypes */
void collect_mb_init(DOLProcess *);
int collect_mb_fire(DOLProcess *);

/* DOL process declaration */
extern DOLProcess collect_mb;

/* additional function prototypes */
void collect_mb_finish(DOLProcess *);
void Update_Picture_Buffers(DOLProcess *);
void frame_reorder(DOLProcess *, int , int );
void Add_Block(DOLProcess *, int , int , int , int );
void Send_Frame(DOLProcess *, unsigned char *[]);


/* additional extern function prototypes */
extern void Error(DOLProcess *, char *);


#endif
