#ifndef DISPATCH_BLOCKS_H
#define DISPATCH_BLOCKS_H

#include <dol.h>
#include "global.h"

#define PORT_OUT "out"
#define PORT_IN "in"

//local variables
typedef struct _local_states {
    char id[64];
    char name[15];
    MbDispatchedDatatype mb_dispatched_datatype;
    GopDispatchedDatatype gop_dispatched_datatype;
    BlockDispatchedDatatype block_dispatched_datatype;    
    int out_port_count;
    int read_buffer[MAX_MB_BUFFER_SIZE];
    int read_buffer_size;
} Dispatch_blocks_State;

/* mandatory function prototypes */
void dispatch_blocks_init(DOLProcess *);
int dispatch_blocks_fire(DOLProcess *);

/* DOL process declaration */
extern DOLProcess dispatch_blocks;

/* additional function prototypes */
void dispatch_blocks_finish(DOLProcess *);
void dispatch(DOLProcess *);

/* additional extern function prototypes */
extern void Error(DOLProcess *, char *);

#endif
