#ifndef TRANSFORM_BLOCK_H
#define TRANSFORM_BLOCK_H

#include <dol.h>
#include "global.h"

#define  PORT_IN "in"
#define  PORT_OUT "out"

// local variables
typedef struct _local_states {
    char id[64];
    char name[15];
    MbDispatchedDatatype mb_dispatched_datatype;
    GopDispatchedDatatype gop_dispatched_datatype;
    BlockDispatchedDatatype block_dispatched_datatype;        
} Transform_block_State;

/* mandatory function prototypes */
void transform_block_init(DOLProcess *);
int transform_block_fire(DOLProcess *);

/* DOL process declaration */
extern DOLProcess transform_block;

/* additional extern function prototypes */
extern void Error(DOLProcess *, char *);

/* additional prototypes */
void transform_block_finish(DOLProcess *);

#endif
